/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.ingreso;

import danielcortes.xyz.data.SQLiteConnectionHolder;
import danielcortes.xyz.models.caja.Caja;
import danielcortes.xyz.models.tipo_ingreso.TipoIngreso;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.time.LocalDate;
import java.time.YearMonth;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

public class SQLiteIngresoDAO extends IngresoDAO {
    private static final Logger LOGGER = Logger.getLogger(SQLiteIngresoDAO.class.getName());

    public SQLiteIngresoDAO() {
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<Ingreso> findAll() {
        List<Ingreso> ingresosList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from ingresos";
            PreparedStatement ps = conn.prepareStatement(query);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0}", query);

            ingresosList = this.ingresosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return ingresosList;
    }

    @Override
    public List<Ingreso> findByCaja(Caja caja) {
        List<Ingreso> ingresosList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from ingresos where caja_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, caja.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, caja.getId()});

            ingresosList = this.ingresosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return ingresosList;
    }

    @Override
    public List<Ingreso> findById(int id) {
        List<Ingreso> ingresosList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select * from ingresos where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, id);
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, id});

            ingresosList = this.ingresosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return ingresosList;
    }

    @Override
    public List<Ingreso> findByTipoIngreso(TipoIngreso tipoIngreso) {
        List<Ingreso> ingresosList = new ArrayList<>();
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select ingresos.* from ingresos inner join tipos_ingreso on (ingresos.tipo_ingreso_id = tipos_ingreso.id) where ingresos.tipo_ingreso_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, tipoIngreso.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, tipoIngreso.getId()});


            ingresosList = this.ingresosFromResultSet(rs);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return ingresosList;
    }

    @Override
    public boolean insertIngreso(Ingreso ingreso) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "insert into ingresos (valor, nro_z_inicial, nro_z_final, nro_inicial, nro_final, tipo_ingreso_id, caja_id) values (?,?,?,?,?,?,?)";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, ingreso.getValor());
            ps.setString(2, ingreso.getNroZInicial());
            ps.setString(3, ingreso.getNroZFinal());
            ps.setString(4, ingreso.getNroInicial());
            ps.setString(5, ingreso.getNroFinal());
            ps.setInt(6, ingreso.getTipoIngreso().getId());
            ps.setInt(7, ingreso.getCaja().getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: [{1},{2},{3},{4},{5},{6},{7}] | updates: {8}", new Object[]{query, ingreso.getValor(), ingreso.getNroZInicial(), ingreso.getNroZFinal(), ingreso.getNroInicial(), ingreso.getNroFinal(), ingreso.getTipoIngreso().getId(), ingreso.getCaja().getId(), updates});

            ps.close();

            ps = conn.prepareStatement("select last_insert_rowid()");
            ResultSet rs = ps.executeQuery();
            rs.next();
            ingreso.setId(rs.getInt(1));

            rs.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean updateIngreso(Ingreso ingreso) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "update ingresos set valor = ?, nro_z_inicial = ?, nro_z_final = ?, nro_inicial = ?, nro_final = ?, tipo_ingreso_id = ?, caja_id = ? where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, ingreso.getValor());
            ps.setString(2, ingreso.getNroZInicial());
            ps.setString(3, ingreso.getNroZFinal());
            ps.setString(4, ingreso.getNroInicial());
            ps.setString(5, ingreso.getNroFinal());
            ps.setInt(6, ingreso.getTipoIngreso().getId());
            ps.setInt(7, ingreso.getCaja().getId());
            ps.setInt(8, ingreso.getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: [{1},{2},{3},{4},{5},{6},{7},{8}] | updates: {9}", new Object[]{query, ingreso.getValor(), ingreso.getNroZInicial(), ingreso.getNroZFinal(), ingreso.getNroInicial(), ingreso.getNroFinal(), ingreso.getTipoIngreso().getId(), ingreso.getCaja().getId(), ingreso.getId(), updates});


            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean deleteIngreso(Ingreso ingreso) {
        int updates;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "delete from ingresos where id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, ingreso.getId());
            updates = ps.executeUpdate();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1} | updates: {2}", new Object[]{query, ingreso.getId(), updates});

            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
            return false;
        }
        return updates > 0;
    }

    @Override
    public int getTotalIngreso(Caja caja) {
        int total = 0;
        try (Connection conn = connectionHolder.getConnection()) {
            String query = "select sum(valor) from ingresos where caja_id = ?";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setInt(1, caja.getId());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}", new Object[]{query, caja.getId()});

            rs.next();
            total = rs.getInt(1);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return total;
    }

    @Override
    public int getTotalIngresoMes(YearMonth mes) {
        int total = 0;
        try (Connection conn = connectionHolder.getConnection()) {
            LocalDate start = mes.atDay(1);
            LocalDate end = mes.atEndOfMonth();
            String query =
                    "select sum(valor) from ingresos inner join caja on (ingresos.caja_id == caja.id) where caja.fecha between ? and ? and ingresos.tipo_ingreso_id != 5";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setString(1, start.toString());
            ps.setString(2, end.toString());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}, {2}", new Object[]{query, start, end});

            rs.next();
            total = rs.getInt(1);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return total;
    }

    @Override
    public int getTotalExentasMes(YearMonth mes) {
        int total = 0;
        try (Connection conn = connectionHolder.getConnection()) {
            LocalDate start = mes.atDay(1);
            LocalDate end = mes.atEndOfMonth();
            String query =
                    "select sum(valor) from ingresos inner join caja on (ingresos.caja_id == caja.id) where caja.fecha between ? and ? and ingresos.tipo_ingreso_id = 5";
            PreparedStatement ps = conn.prepareStatement(query);
            ps.setString(1, start.toString());
            ps.setString(2, end.toString());
            ResultSet rs = ps.executeQuery();

            LOGGER.log(Level.FINE, "QUERY: {0} | values: {1}, {2}", new Object[]{query, start, end});

            rs.next();
            total = rs.getInt(1);

            rs.close();
            ps.close();
        } catch (SQLException e) {
            LOGGER.log(Level.SEVERE, e.toString(), e);
        }
        return total;
    }
}
